-- 组队赛 队伍排行
checkRequire("Lua_RankBasePanel")
Lua_FormTeamCompetitionRankPanel = class("Lua_FormTeamCompetitionRankPanel", Lua_RankBasePanel)
function Lua_FormTeamCompetitionRankPanel:ctor(p)
	self:superCall("ctor", p, "FormTeamCompetitionRankPanel_skin")
end

function Lua_FormTeamCompetitionRankPanel:buildShowItem()
	self:superCall("buildShowItem")

	self.myNoneRankSp:setEnable(true);
	self.myRankObj:SetActive(false);

	if self.myAvatarItem then
		self.myAvatarItem:setEnable(false);
	end

	local item
	for i = 1, 3 do
		item = Lua_FormTeamCompetitionRankTopItem.new(self.content)
		item.contentName = "topRank_"..i
		item:setRectAnchor(1)
		item:setLocation(self.topPos[i][1], self.topPos[i][2], 0)
		self.topArr:add(item)
	end
	
	self.itemList:setListCell(Lua_FormTeamCompetitionRankItem, 688, 125, 1)
end

function Lua_FormTeamCompetitionRankPanel:dispose()
	self:superCall("dispose")
end

function Lua_FormTeamCompetitionRankPanel:updateRankInfo(msg)
	-- if self.bRefresh then
		local len = self.rankArr:getSize()
		local num = len - #msg.rank_list

		while (num > 0) do
			self.rankArr:remove()
			num = num - 1
		end
		for i = 1, #msg.rank_list do
			if i > len then
				self.rankArr:add(msg.rank_list[i])
			else
				self.rankArr[i] = msg.rank_list[i]
			end
		end
	-- else
	-- 	for i = 1, #msg.rank_list do
	-- 		self.rankArr:add(msg.rank_list[i])
	-- 	end
	-- end
	self.itemList.isPageEnd = true;
	self:updateRankList() 

	local info = msg.my_rank;
	if info == nil then
		self.myNoneRankSp:setEnable(true);
		self.myRankObj:SetActive(false);
		if self._myRankNum then self._myRankNum:setEnable(false) end
	else
		if info.team_id == nil or tonumber(info.team_id) <= 0 then
			self.myNoneRankSp:setEnable(true);
			self.myRankObj:SetActive(false);
			if self._myRankNum then self._myRankNum:setEnable(false) end
		else
			if info.rank < 1 then
				self.myNoneRankSp:setEnable(true);
				if self._myRankNum then self._myRankNum:setEnable(false) end
			else
				self.myNoneRankSp:setEnable(false);
				self.myRankNum.num = info.rank;
			end
			self.myTeamNameTxt.text = info.team_name;

			self.myTeamForceNumTxt.text = numberTrans(tonumber(info.force));
			self.myTeamScoreNumTxt.text = info.score;

			local str, url = DataCenter.formTeamCompetitionUtil:getTeamLevel(tonumber(info.grade), 2);
			self.myTeamStageTxt.text = str;
			self.myTeamStageSp:setUrl(url);
			self.myTeamStageBg:setEnable(str ~= nil)
			self.myRankObj:SetActive(true);
		end
	end
end

function Lua_FormTeamCompetitionRankPanel:updateTopRank()
	for i = 1, 3 do
		self.topArr[i]:setData(self.data.type, i, self.rankArr[i])
		self.topArr[i]:setEnable(true);
	end
	self:updateTween()
	self:updateMainPlaneTopRankItem();
end

function Lua_FormTeamCompetitionRankPanel:updateMainPlaneTopRankItem()
	local ranks = {};
	if self.rankArr ~= nil then
		local index = self.rankArr:getSize();
		index = index > 3 and 3 or index;
		for i = 1, index do
			ranks[i] = self.rankArr[i];
		end

	end
	Lua_MsgUtil.callFunc("UPDATE_FORMTEAMCOMPETITION_MAIN_INFO_TOPRANK", ranks);
end